#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <termios.h>
#include <fcntl.h>
#include <signal.h>

#include <bits/signum.h>
//#include <asm/signal.h>
//#define SIGALRM 14

#define cls fprintf(stderr,"\e[2J")
#define move(X,Y) fprintf(stderr,"\e[%i;%iH",Y,X)
#define ROWS 25
#define CURSOR(Y)  move(1,Y);\
 fprintf(stderr,"\e[1m\e[m") /*  v =  */
static int cury=2;
static int begin=0;
static int level=1;

#define OFF  0
#define UP   1
#define DOWN 2
static int cursor=OFF;

#define TITLE_PASSWD "USER\t     PASSWORD\tUID\tGID\tINFORMATION"
//pid,ppid,pgrp,session,priority,vsize,rss,state,*tty=='?'? tty:tty+5
#define TITLE_PS     "NAME             PID  PPID  PGRP SESSION NI  VSIZE    RSS  %MEM STATE TTY"
#define TITLE_HELP   "          "

#define MAX_ETC_PASSWD 1000

static char* etc_passwd[MAX_ETC_PASSWD];
static int   etc_passwdc = 0;

#define MAX_PW 10000

static char* pw[MAX_PW];
static int   pwm[MAX_PW];
static int   pwc = 0;
static int   mark=0;

#define SIZE_SIG 38
static char* sig[SIZE_SIG]={
"SIGHUP        1         A            ",
"SIGINT        2         A         ",
"SIGQUIT       3         C         ",
"SIGILL        4         C        ",
"SIGABRT       6         C        ,   abort(3)",
"SIGFPE        8         C           ",
"SIGKILL       9        AEF      Kill-",
"SIGSEGV      11         C           ",
"SIGPIPE      13         A        ",
"SIGALRM      14         A           alarm(2)",
"SIGTERM      15         A        ",
"SIGUSR1     30,10,16    A        ,  ",
"SIGUSR2     31,12,17    A        ,  ",
"SIGCHLD     20,17,18    B           ",
"SIGCONT     19,18,25             ,  ",
"SIGSTOP     17,19,23   DEF        ",
"SIGTSTP     18,20,24    D          ",
"SIGTTIN     21,21,26    D            ",
"SIGTTOU     22,22,27    D            ",
"SIGBUS      10,7,10     C         (   )",
"SIGPOLL                 A         (Sys V).  SIGIO",
"SIGPROF     27,27,29    A          ",
"SIGSYS      12,-,12     C          (SVID)",
"SIGTRAP        5        C       /",
"SIGURG      16,23,21    B           (4.2 BSD)",
"SIGVTALRM   26,26,28    A         (4.2 BSD)",
"SIGXCPU     24,24,30    C           (4.2 BSD)",
"SIGXFSZ     25,25,31    C            (4.2 BSD)",
"SIGIOT         6        C       IOT-.   SIGABRT",
"SIGEMT       7,-,7",
"SIGSTKFLT    -,16,-     A         ",
"SIGIO       23,29,22    A       I/O   (4.2 BSD)",
"SIGCLD       -,-,18               SIGCHLD",
"SIGPWR      29,30,19    A          (System V)",
"SIGINFO      29,-,-               SIGPWR",
"SIGLOST      -,-,-      A         ",
"SIGWINCH    28,28,20    B          (4.3 BSD, Sun)",
"SIGUNUSED    -,31,-     A         (   SIGSYS)"
};

static FILE* 		f;
static DIR* 		proc;
static struct dirent*	file; 
static struct stat	sbuf;
static int __uid = 0;

#define MAX_BUF 127

static char df[MAX_BUF]="/proc/";
static char buf[MAX_BUF];
static char buff[MAX_BUF];

static struct termios term;
static tcflag_t oldflags;
static int  cterm; // 

void mode();
void reset();
void load_etc_passwd();
int menu(char*,void (*resize)());
void set_passwd();
void set_ps();
void sigusr(int sig);

main()
{
 int m_ps,m_passwd,m;
 mode();
 
 load_etc_passwd();

MENU_PASSWD:  
 level = 1;
 if( menu(TITLE_PASSWD,set_passwd)=='\n' )
 {
  m_passwd = mark;
  __uid = pwm[begin+cury-2];
  mark = 0;
MENU_PS:
  level = 2;
  m = menu(TITLE_PS,set_ps);
  if( m=='s' )
  {
  int i;
  m_ps = mark;
  mark = 0;
  for(i=0; i<pwc; i++) free(pw[i]);
  for(i=0; i<SIZE_SIG; i++) pw[i]=strdup(sig[i]), pwm[i]=i;
  pwc = SIZE_SIG;
  cls;
  menu(TITLE_HELP,NULL);
  mark = m_ps;
  goto MENU_PS;
  }
  else if( m=='k' )
  {
   char s[10];
   int i, c, x=20, y=10;
   move(x-1,y  ); fprintf(stderr,"------------- Signal number ------------");
   move(x-1,y+1); fprintf(stderr,"                                       ");
   move(x-1,y+2); fprintf(stderr,"L----------------------------------------");
   move(x+1,y+1);
   for(i=0; (c=fgetc(stdin))!='\n';) 
   if( isdigit(c) && i<18 ) buf[i]=c, fprintf(stderr,"%c",c), i++;
   else if( c==127 && i>0 ) move(x+i,y+1),fprintf(stderr," "),move(x+i,y+1), i--;
   else if( c=='q' || c=='\e' ) goto MENU_PS;
   buf[i]='\0';

   kill( mark, atoi(buf) );
   goto MENU_PS;
  }  
  mark = m_passwd;
  goto MENU_PASSWD;
 }

 reset();
}

static void (*Resize)(); //   pw

void sigusr(int sig) //   SIGALRM
{
 int i,y=2;
 char* s;
 
 if(Resize!=NULL)	Resize();

 for(i=0; i<pwc-1 && pwm[i]<mark; i++); //  
 if(pwm[i]!=mark && i!=0) i--;

 /*   */
 if( cursor==UP && begin+cury-2-1>=0 ) i--;
 else if( cursor==DOWN && begin+cury-2 < pwc-1 ) i++;

 cursor = OFF;

 if( begin>i ) begin = i;
 else if( begin+ROWS-2<i ) begin=i-ROWS+2;

 if(pwc-begin<ROWS-2 && pwc>ROWS-2) begin = pwc-ROWS+2;

 move(1,cury);
 fprintf(stderr," ");
 
 cury = i - begin + 2;
 
 CURSOR(cury);

 for(i=begin; i<pwc && i<begin+ROWS-1; move(2,y++), fprintf(stderr,"%s\e[K",pw[i++]));
 fprintf(stderr,"\e[J");

 mark = pwm[begin+cury-2]; //    
 
 alarm(1);
}

int menu(char* Title,void (*resize)() )
{
 int i,c;

 cls;
 begin = 0;
 Resize = resize;

 move(2,1);
 fprintf(stderr,"\e[1m%s\e[m\e[K",Title);
 
 signal(SIGALRM,sigusr);
 raise(SIGALRM);
 alarm(1);
 
 while( ( c=fgetc(stdin) )!='q' )
 {
  if( c=='x' ) reset();
  if( c=='\n' ) goto RETURN;
  if( c=='k' && level==2 ) goto RETURN;
  if( c=='s' && level==2 ) goto RETURN;
  if( !pwc ) continue;
  
  if( c=='\e' && fgetc(stdin)=='[')
  { 
   c = fgetc(stdin);
   if( c=='A' )      cursor = UP, raise(SIGALRM);  // 
   else if( c=='B' ) cursor = DOWN, raise(SIGALRM);// 
  }
 } 
 RETURN:
 signal(SIGALRM,SIG_IGN);
 return c;
 
}

static st_mtime;
void load_etc_passwd()
{
    stat("/etc/passwd",&sbuf);
    if(etc_passwdc)
    {
     if(sbuf.st_mtime!=st_mtime)
      for(etc_passwdc--;etc_passwdc+1; etc_passwdc--) free(etc_passwd[etc_passwdc]);
     else return;
    }
    
    st_mtime=sbuf.st_mtime;
    f = fopen("/etc/passwd","r");
    while( fgets(buf,MAX_BUF,f) )
    {
     int i; char* s;
     buf[strlen(buf)-1]='\0';
     s=strchr(buf,':');
     *s = '\t';
     if(s-buf<8) memmove(s+1,s,strlen(s));
     for(i=0; i<3; i++) *strchr(buf,':')='\t';
     *strchr(buf,':')='\0';
     etc_passwd[etc_passwdc++]=strdup(buf);
    }
    fclose(f);
}

int nisd(char* s){ for(;*s; s++) if(!isdigit(*s)) return 1; return 0; }

void __set_passwd(int priznak)
{
  int i;
  for(i=0; i<pwc; i++) free(pw[i]);
  pwc=0;
  
  load_etc_passwd();

 proc = opendir("/proc");
 if(!proc) perror("whodo"), exit(1);
 while( file=readdir(proc) )
 {
   if( nisd(file->d_name) ) continue;
   df[strlen("/proc/")]='\0';
   strcat(df,file->d_name);
   if( stat(df,&sbuf) ){ fprintf(stderr,"df=%s\n",df); continue;}
   if( S_ISDIR(sbuf.st_mode) )
   {
    FILE* f; int i, uid; char* s;
    strcat(df,"/status");
    f=fopen(df,"r");
    if(!f){ fprintf(stderr,"whodo:    %s\n",df); continue;}

    for(i=0; i<6; i++) fgets(buf,MAX_BUF,f);
    s=buf;
    while(!isdigit(*s)) s++;

    uid=atoi(s);

if( priznak )
{
    for(i=0; i<pwc; i++)
    {
     s=pw[i];
     while( !isdigit(*s) ) s++;
     if( atoi(s)==uid ) goto BREAK;
    } 
    for(i=0; i<etc_passwdc; i++)
    {
     s=etc_passwd[i];
     while( !isdigit(*s) ) s++;
     if( atoi(s)==uid )
     {
      pwm[pwc]=uid;
      pw[pwc++]=strdup(etc_passwd[i]);
      break;
     }     
    }
BREAK:
}
else if( __uid==uid )
{
#define R 7
 FILE* t;
 int k,i=0;
 pid_t pid, ppid, pgrp, ptty, session, priority;
 unsigned long vsize, rss, mem;
 float pmem;


 char state, tty[MAX_BUF];
 
 df[strlen(df)-2]='\0'; 
 
  t = fopen(df,"r");
  if( !t ) perror("whodo"),exit(10);
  
  fscanf(t,"%i",&pid); // pid
  
  while( fgetc(t)!='(');
  while( (k=fgetc(t)) != ')' ) buff[i++]=k;
  buff[i]='\0';
  fgetc(t);

  fscanf(t,"%c",&state);
  fscanf(t,"%i",&ppid);
  fscanf(t,"%i",&pgrp);
  fscanf(t,"%i",&session);	// session
  fscanf(t,"%i",&ptty); // tty
  
  fscanf(t,"%*i%*u%*u%*u%*u%*u%*d%*d%*d%*d%*d");
//	     t  f mf cmf af jf ut st ct st cn
  fscanf(t,"%i",&priority);

  fclose(t);
  
  t = fopen("/proc/meminfo","r");
  if(!t) perror("whodo"), exit(30);
  
  fgets(buf,MAX_BUF,t);  fgets(buf,MAX_BUF,t);
  s = strchr(buf,':');
  mem = atoi(s+2); 
  
  fclose(t);

  if( ptty==0 ) tty[0]='?', tty[1]='\0';
  else
  {
   char x[15];

   df[strlen("/proc/")] = '\0';
   sprintf(x,"%i",pgrp);
   strcat(df,x);
   strcat(df,"/fd/0");
  
   k = readlink(df,tty,MAX_BUF);
   if( k == -1 ) k = 1, *tty = '?';
   tty[k] = '\0';
  } 
  
   fseek(f,0,0);

   for(i=0; i<10; i++) fgets(buf,MAX_BUF,f);
   if( memcmp("VmSize",buf,6)==0 )
   {
    s = strchr(buf,'\t');
    vsize = atoi(s);
    fgets(buf,MAX_BUF,f); fgets(buf,MAX_BUF,f);
    s = strchr(buf,'\t')+1;
    rss = atoi(s);
   }
   else 
   {
    vsize = rss = 0;
   }
   
  for(k = strlen(buff); k<14; k++) strcat(buff," ");
  
  pmem = rss*100*4096;
  pmem = pmem / mem;

  
  sprintf(buff+strlen(buff)," %5i %5i %5i %6i %3i %6u %6u %5.2f %c     %s",pid,ppid,pgrp,session,priority,vsize,rss,pmem,state,*tty=='?'? tty:tty+5);


  
  pwm[pwc] = pid;
  pw[pwc++]=strdup(buff);
}
    fclose(f);
  }
 }
 closedir(proc);
 
}

void set_ps()
{
 __set_passwd(0);
}

void set_passwd()
{
 __set_passwd(1);
}

void mode()
{
    cterm = open("/dev/tty",O_RDWR);
    tcflush(cterm,TCIOFLUSH); //  
    tcgetattr(cterm,&term);  //  
    oldflags = term.c_lflag;	  //       	
    //    ,
    //   SIGTTOU ( TOSTOP)
    //  SIGINT, SIGQUIT, SIGTSTP ( ISIG)
    term.c_lflag=term.c_lflag&(~ICANON)&(~ECHO)|TOSTOP|ISIG;	
    tcsetattr(cterm,TCSANOW,&term); //  
}
void reset(){
    signal(SIGALRM,SIG_IGN);
    term.c_lflag=oldflags;	
    tcsetattr(cterm,TCSANOW,&term); // 
    cls;
    move(1,1);
    exit(0);
}

/*   for(k=strlen(s); k<R; k++) strcat(buff," ");
   fgets(buf,MAX_BUF,f);
   for(i=0; i<5; i++){
    fgets(buf,MAX_BUF,f);
    s = strchr(buf,'\t')+1;
    s = strtok(s,"\t \n\v");
    strcat(buff,s);
    if(i!=5) for(k=strlen(s); k<R; k++) strcat(buff," ");
   }
   */
